/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-06-27 at 23:50:51 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.freebase.model;

/**
 * Model definition for TopicValue.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Freebase API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TopicValue extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Citation citation;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String creator;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String dataset;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String lang;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String project;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, TopicPropertyvalue> property;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String text;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String timestamp;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Object value;

  /**
   * @return value or {@code null} for none
   */
  public Citation getCitation() {
    return citation;
  }

  /**
   * @param citation citation or {@code null} for none
   */
  public TopicValue setCitation(Citation citation) {
    this.citation = citation;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getCreator() {
    return creator;
  }

  /**
   * @param creator creator or {@code null} for none
   */
  public TopicValue setCreator(java.lang.String creator) {
    this.creator = creator;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getDataset() {
    return dataset;
  }

  /**
   * @param dataset dataset or {@code null} for none
   */
  public TopicValue setDataset(java.lang.String dataset) {
    this.dataset = dataset;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * @param id id or {@code null} for none
   */
  public TopicValue setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getLang() {
    return lang;
  }

  /**
   * @param lang lang or {@code null} for none
   */
  public TopicValue setLang(java.lang.String lang) {
    this.lang = lang;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getProject() {
    return project;
  }

  /**
   * @param project project or {@code null} for none
   */
  public TopicValue setProject(java.lang.String project) {
    this.project = project;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.util.Map<String, TopicPropertyvalue> getProperty() {
    return property;
  }

  /**
   * @param property property or {@code null} for none
   */
  public TopicValue setProperty(java.util.Map<String, TopicPropertyvalue> property) {
    this.property = property;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getText() {
    return text;
  }

  /**
   * @param text text or {@code null} for none
   */
  public TopicValue setText(java.lang.String text) {
    this.text = text;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getTimestamp() {
    return timestamp;
  }

  /**
   * @param timestamp timestamp or {@code null} for none
   */
  public TopicValue setTimestamp(java.lang.String timestamp) {
    this.timestamp = timestamp;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Object getValue() {
    return value;
  }

  /**
   * @param value value or {@code null} for none
   */
  public TopicValue setValue(java.lang.Object value) {
    this.value = value;
    return this;
  }

  @Override
  public TopicValue set(String fieldName, Object value) {
    return (TopicValue) super.set(fieldName, value);
  }

  @Override
  public TopicValue clone() {
    return (TopicValue) super.clone();
  }

  /**
   * Model definition for TopicValueCitation.
   */
  public static final class Citation extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String provider;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String statement;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String uri;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getProvider() {
      return provider;
    }

    /**
     * @param provider provider or {@code null} for none
     */
    public Citation setProvider(java.lang.String provider) {
      this.provider = provider;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getStatement() {
      return statement;
    }

    /**
     * @param statement statement or {@code null} for none
     */
    public Citation setStatement(java.lang.String statement) {
      this.statement = statement;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getUri() {
      return uri;
    }

    /**
     * @param uri uri or {@code null} for none
     */
    public Citation setUri(java.lang.String uri) {
      this.uri = uri;
      return this;
    }

    @Override
    public Citation set(String fieldName, Object value) {
      return (Citation) super.set(fieldName, value);
    }

    @Override
    public Citation clone() {
      return (Citation) super.clone();
    }

  }

}
